> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nscale.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List endpoints

> List the object storage endpoints with optional filtering by tag, organization, project, and region.



## OpenAPI

````yaml /openapi/storage-openapi.yaml get /api/v1/objectstorageendpoints
openapi: 3.0.3
info:
  title: Storage Service API
  description: |-
    The Storage Service API provides that allows provisioning and life cycle
    management of File and Object storage.
  version: 1.13.0
servers: []
security: []
paths:
  /api/v1/objectstorageendpoints:
    description: >-
      Manages S3-compatible object storage endpoints, enabling users to
      self-serve bucket creation through the access they provide.
    get:
      tags:
        - Object storage
      summary: List endpoints
      description: >-
        List the object storage endpoints with optional filtering by tag,
        organization, project, and region.
      parameters:
        - $ref: '#/components/parameters/tagSelectorParameter'
        - $ref: '#/components/parameters/organizationIDQueryParameter'
        - $ref: '#/components/parameters/projectIDQueryParameter'
        - $ref: '#/components/parameters/regionIDQueryParameter'
      responses:
        '200':
          $ref: '#/components/responses/objectStorageEndpointListResponse'
        '400':
          $ref: '#/components/responses/badRequestResponse'
        '401':
          $ref: '#/components/responses/unauthorizedResponse'
        '403':
          $ref: '#/components/responses/forbiddenResponse'
        '500':
          $ref: '#/components/responses/internalServerErrorResponse'
      security:
        - oauth2Authentication: []
components:
  parameters:
    tagSelectorParameter:
      name: tag
      in: query
      description: |-
        A set of tags to match against resources in the form "name=value",
        thus when encoded you get "?tag=foo%3Dcat&tag=bar%3Ddog".
      schema:
        type: array
        items:
          type: string
    organizationIDQueryParameter:
      name: organizationID
      in: query
      description: Allows resources to be filtered by organization.
      schema:
        type: array
        items:
          type: string
    projectIDQueryParameter:
      name: projectID
      in: query
      description: Allows resources to be filtered by project.
      schema:
        type: array
        items:
          type: string
    regionIDQueryParameter:
      name: regionID
      in: query
      description: Allows resources to be filtered by region.
      schema:
        type: array
        items:
          type: string
          minLength: 1
  responses:
    objectStorageEndpointListResponse:
      description: A list of object storage endpoints.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/objectStorageEndpointList'
          example:
            - metadata:
                id: a64f9269-36e0-4312-b8d1-52d93d569b7b
                name: my-s3-endpoint
                organizationId: 9a8c6370-4065-4d4a-9da0-7678df40cd9d
                projectId: e36c058a-8eba-4f5b-91f4-f6ffb983795c
                creationTime: '2024-05-31T14:11:00Z'
                createdBy: john.doe@acme.com
                provisioningStatus: provisioned
                healthStatus: healthy
                tags:
                  - name: tag-name
                    value: tag-value
              spec:
                objectStorageEndpointClassId: 7b6f8b33-3ca8-4db2-b7ab-7bbf683efc6d
                identityPolicies:
                  - name: bucket-admin
                    document:
                      Version: '2012-10-17'
                      Statement:
                        - Effect: Allow
                          Action:
                            - s3:ListBucket
                            - s3:GetObject
                          Resource:
                            - arn:aws:s3:::example-bucket
                            - arn:aws:s3:::example-bucket/*
              status:
                regionId: ba39bff5-b0d8-4c60-89e5-ed1104356b4a
                exposure:
                  public:
                    dnsName: s3.example.com
    badRequestResponse:
      description: |-
        Request body failed schema validation, or the request does not contain
        all the required fields.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: invalid_request
            error_description: request body invalid
            trace_id: 57bc14d9bd461f0b5a72db830149b67a
    unauthorizedResponse:
      description: Authentication failed or the access token has expired.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: access_denied
            error_description: authentication failed
            trace_id: 57bc14d9bd461f0b5a72db830149b67a
    forbiddenResponse:
      description: >-
        Request was denied by authorization, this may be caused by the
        authorization

        token not having the required scope for an API, or the user doesn't have
        the

        necessary privileges on the provider platform.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: forbidden
            error_description: user credentials do not have the required privileges
            trace_id: 57bc14d9bd461f0b5a72db830149b67a
    internalServerErrorResponse:
      description: >-
        An unexpected or unhandled error occurred. This may be a transient error
        and

        may succeed on a retry.  If this isn't the case, please report it as an
        issue.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: server_error
            error_description: failed to token claim
            trace_id: 57bc14d9bd461f0b5a72db830149b67a
  schemas:
    objectStorageEndpointList:
      description: A list of object storage endpoints.
      type: array
      items:
        $ref: '#/components/schemas/objectStorageEndpointRead'
    error:
      description: Generic error message, compatible with oauth2.
      type: object
      required:
        - error
        - error_description
      properties:
        error:
          description: >-
            A terse error string expanding on the HTTP error code. Errors are
            based on the OAuth 2.02 specification, but are expanded with
            proprietary status codes for APIs other than those specified by
            OAuth 2.02.
          type: string
          enum:
            - invalid_request
            - server_error
            - access_denied
            - not_found
            - conflict
            - method_not_allowed
            - unsupported_media_type
            - request_entity_too_large
            - unprocessable_content
            - forbidden
        error_description:
          description: Verbose message describing the error.
          type: string
        trace_id:
          description: Unique trace identifier for the request.
          type: string
    objectStorageEndpointRead:
      description: >-
        An S3-compatible object storage endpoint that allows users to
        self-service create buckets through the access it exposes.
      type: object
      required:
        - metadata
        - spec
        - status
      properties:
        metadata:
          $ref: '#/components/schemas/projectScopedResourceReadMetadata'
        spec:
          $ref: '#/components/schemas/objectStorageEndpointSpec'
        status:
          $ref: '#/components/schemas/objectStorageEndpointStatus'
    projectScopedResourceReadMetadata:
      description: Metadata required by project scoped resource reads.
      allOf:
        - $ref: '#/components/schemas/organizationScopedResourceReadMetadata'
        - type: object
          required:
            - projectId
          properties:
            projectId:
              description: The project identifier the resource belongs to.
              type: string
    objectStorageEndpointSpec:
      description: An object storage endpoint specification.
      type: object
      required:
        - objectStorageEndpointClassId
      properties:
        objectStorageEndpointClassId:
          description: >-
            The immutable object storage endpoint class selected when the
            endpoint was created.
          type: string
        identityPolicies:
          $ref: '#/components/schemas/objectStorageIdentityPolicyList'
          description: >-
            The identity policies configured for this object storage endpoint.
            Policy names must be unique within the endpoint.
    objectStorageEndpointStatus:
      description: The observed status of an object storage endpoint.
      type: object
      required:
        - regionId
      properties:
        regionId:
          description: The region the object storage endpoint is provisioned in.
          type: string
        exposure:
          $ref: '#/components/schemas/objectStorageEndpointExposureStatus'
    organizationScopedResourceReadMetadata:
      description: Metadata required by organization scoped resource reads.
      allOf:
        - $ref: '#/components/schemas/resourceReadMetadata'
        - type: object
          required:
            - organizationId
          properties:
            organizationId:
              description: The organization identifier the resource belongs to.
              type: string
    objectStorageIdentityPolicyList:
      description: A list of identity policies configured for an object storage endpoint.
      type: array
      items:
        $ref: '#/components/schemas/objectStorageIdentityPolicySpec'
    objectStorageEndpointExposureStatus:
      description: The externally reachable endpoints for an object storage endpoint.
      type: object
      properties:
        public:
          $ref: '#/components/schemas/objectStorageEndpointExposureDetailsStatus'
    resourceReadMetadata:
      description: Metadata required by all resource reads.
      allOf:
        - $ref: '#/components/schemas/staticResourceMetadata'
        - type: object
          required:
            - provisioningStatus
            - healthStatus
          properties:
            deletionTime:
              description: The time the resource was deleted.
              type: string
              format: date-time
            provisioningStatus:
              $ref: '#/components/schemas/resourceProvisioningStatus'
            healthStatus:
              $ref: '#/components/schemas/resourceHealthStatus'
    objectStorageIdentityPolicySpec:
      description: A named identity policy configured for an object storage endpoint.
      type: object
      required:
        - name
        - document
      properties:
        name:
          description: >-
            The identity policy name. Names must be unique within the object
            storage endpoint.
          type: string
          minLength: 1
        document:
          $ref: '#/components/schemas/objectStorageIdentityPolicyDocument'
    objectStorageEndpointExposureDetailsStatus:
      description: Connection details for a specific exposure mode.
      type: object
      required:
        - dnsName
      properties:
        dnsName:
          description: The DNS hostname clients use to reach the endpoint.
          type: string
    staticResourceMetadata:
      description: |
        This metadata is for resources that just exist, and don't require
        any provisioning and health status, but benefit from a standardized
        metadata format.
      type: object
      allOf:
        - $ref: '#/components/schemas/resourceMetadata'
        - type: object
          required:
            - id
            - creationTime
          properties:
            id:
              description: The unique resource ID.
              type: string
            creationTime:
              description: The time the resource was created.
              type: string
              format: date-time
            createdBy:
              description: The user who created the resource.
              type: string
            modifiedTime:
              description: The time a resource was updated.
              type: string
              format: date-time
            modifiedBy:
              description: The user who updated the resource.
              type: string
    resourceProvisioningStatus:
      description: The provisioning state of a resource.
      type: string
      enum:
        - unknown
        - pending
        - provisioning
        - provisioned
        - deprovisioning
        - error
    resourceHealthStatus:
      description: The health state of a resource.
      type: string
      enum:
        - unknown
        - healthy
        - degraded
        - error
    objectStorageIdentityPolicyDocument:
      description: >-
        A provider-specific identity policy document represented as an arbitrary
        JSON object.
      type: object
      additionalProperties: true
    resourceMetadata:
      description: Metadata required for all API resource reads and writes.
      required:
        - name
      properties:
        name:
          $ref: '#/components/schemas/kubernetesLabelValue'
        description:
          description: >-
            The resource description, this optionally augments the name with
            more context.
          type: string
        tags:
          $ref: '#/components/schemas/tagList'
    kubernetesLabelValue:
      description: >-
        A valid Kubernetes label value, typically used for resource names that
        can be

        indexed in the database.
      type: string
      pattern: ^[0-9A-Za-z](?:[0-9A-Za-z-_.]{0,61}[0-9A-Za-z])?$
    tagList:
      description: A list of tags.
      type: array
      items:
        $ref: '#/components/schemas/tag'
    tag:
      description: >-
        A tag mapping arbitrary names to values.  These have no special meaning

        for any component are are intended for use by end users to add
        additional

        context to a resource, for example to categorize it.
      type: object
      required:
        - name
        - value
      properties:
        name:
          description: A unique tag name.
          type: string
        value:
          description: The value of the tag.
          type: string
  securitySchemes:
    oauth2Authentication:
      description: Operation requires OAuth 2.0 bearer token authentication.
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://identity.nks.europe-west4.nscale.com/oauth2/v2/authorization
          tokenUrl: https://identity.nks.europe-west4.nscale.com/oauth2/v2/token
          scopes: {}

````